package maze_singleton;

class MazeFactory {

  private static MazeFactory _theFactory = null;

  private MazeFactory() {
  }

  public static MazeFactory instance() {
    if (_theFactory == null) {
      _theFactory = new MazeFactory();
    }
    return _theFactory;
  }

  public Maze makeMaze() {
    return new Maze();
  }

  public Wall makeWall() {
    return new Wall();
  }

  public Room makeRoom() {
    return new Room();
  }

  public Door makeDoor(Room r1, Room r2) {
    return new Door(r1, r2);
  }
}
